package com.jasamedika.medifirst2000.controller;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.PapInstruksiPerjanjianService;
import com.jasamedika.medifirst2000.vo.PapInstruksiPerjanjianVO;
import com.jasamedika.medifirst2000.vo.PasienInstruksiPerjanjianVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

/**
 * Controller class for Pengakjian Awal Gawat Darurat Business
 * 
 * @author Askur
 */
@RestController
@RequestMapping("/instruksi-perjanjian")
@JsonIgnoreProperties(ignoreUnknown = true)
public class PapInstruksiPerjanjianController extends LocaleController<PapInstruksiPerjanjianVO> {

	private static final Logger LOGGER = getLogger(PapInstruksiPerjanjianController.class);

	@Autowired
	private PapInstruksiPerjanjianService papInstruksiPerjanjianService;

	@RequestMapping(value = "/save-instruksi-perjanjian", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody PasienInstruksiPerjanjianVO vo,
			HttpServletRequest request) {
		try {
			Map<String, Object> result = papInstruksiPerjanjianService.addInstruksiPerjanjian(vo);
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			result.put("message", "Berhasil");
			SaveLog("Perjanjian", "Instruksi");
			return getJsonResponse(result, CREATED);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when addInstruksiPerjanjian", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when addInstruksiPerjanjian", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/get-informasi-perjanjian", method = GET)
	public ResponseEntity<Map<String, Object>> getInformasiPerjanjian(HttpServletRequest request,
			@RequestParam(value = "pasienId") Integer pasienId, @RequestParam(value = "ruanganId") Integer ruanganId) {
		try {
			Map<String, Object> result = papInstruksiPerjanjianService.getInformasiPerjanjian(pasienId, ruanganId);
			return getJsonResponse(result, OK);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when getInformasiPerjanjian", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when getInformasiPerjanjian", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

}
